home *** CD-ROM | disk | FTP | other *** search
/ PC World Komputer 2010 April / PCWorld0410.iso / hity wydania / Ubuntu 9.10 PL / karmelkowy-koliberek-desktop-9.10-i386-PL.iso / casper / filesystem.squashfs / var / lib / dpkg / info / x11-common.postrm < prev    next >
Text File  |  2009-10-19  |  32KB  |  946 lines

  1. #!/bin/sh
  2. # Debian x11-common package post-removal script
  3. # Copyright 1998--2001, 2003 Branden Robinson.
  4. # Licensed under the GNU General Public License, version 2.  See the file
  5. # /usr/share/common-licenses/GPL or <http://www.gnu.org/copyleft/gpl.txt>.
  6. # Acknowlegements to Stephen Early, Mark Eichin, and Manoj Srivastava.
  7.  
  8.  
  9. set -e
  10.  
  11. THIS_PACKAGE=x11-common
  12. THIS_SCRIPT=postrm
  13. CONFIG_DIR=/etc/X11
  14. XWRAPPER_CONFIG="$CONFIG_DIR/Xwrapper.config"
  15. CONFIG_AUX_DIR=/var/lib/x11
  16. XWRAPPER_CONFIG_CHECKSUM="$CONFIG_AUX_DIR/${XWRAPPER_CONFIG##*/}.md5sum"
  17. XWRAPPER_CONFIG_ROSTER="$CONFIG_AUX_DIR/${XWRAPPER_CONFIG##*/}.roster"
  18.  
  19. # $Id$
  20.  
  21. # This is the X Strike Force shell library for X Window System package
  22. # maintainer scripts.  It serves to define shell functions commonly used by
  23. # such packages, and performs some error checking necessary for proper operation
  24. # of those functions.  By itself, it does not "do" much; the maintainer scripts
  25. # invoke the functions defined here to accomplish package installation and
  26. # removal tasks.
  27.  
  28. # If you are reading this within a Debian package maintainer script (e.g.,
  29. # /var/lib/dpkg)info/PACKAGE.{config,preinst,postinst,prerm,postrm}), you can
  30. # skip past this library by scanning forward in this file to the string
  31. # "GOBSTOPPER".
  32.  
  33. SOURCE_VERSION=1:7.4+3ubuntu7
  34. OFFICIAL_BUILD=
  35.  
  36. # Use special abnormal exit codes so that problems with this library are more
  37. # easily tracked down.
  38. SHELL_LIB_INTERNAL_ERROR=86
  39. SHELL_LIB_THROWN_ERROR=74
  40. SHELL_LIB_USAGE_ERROR=99
  41.  
  42. # old -> new variable names
  43. if [ -z "$DEBUG_XORG_PACKAGE" ] && [ -n "$DEBUG_XFREE86_PACKAGE" ]; then
  44.   DEBUG_XORG_PACKAGE="$DEBUG_XFREE86_PACKAGE"
  45. fi
  46. if [ -z "$DEBUG_XORG_DEBCONF" ] && [ -n "$DEBUG_XFREE86_DEBCONF" ]; then
  47.   DEBUG_XORG_DEBCONF="$DEBUG_XFREE86_DEBCONF"
  48. fi
  49.  
  50. # initial sanity checks
  51. if [ -z "$THIS_PACKAGE" ]; then
  52.   cat >&2 <<EOF
  53. Error: package maintainer script attempted to use shell library without
  54. definining \$THIS_PACKAGE shell variable.  Please report the package name,
  55. version, and the text of this error message to the Debian Bug Tracking System.
  56. Visit <http://www.debian.org/Bugs/Reporting> on the World Wide Web for
  57. instructions, read the file /usr/share/doc/debian/bug-reporting.txt from the
  58. "doc-debian" package, or install the "reportbug" package and use the command of
  59. the same name to file a report against version $SOURCE_VERSION of this package.
  60. EOF
  61.   exit $SHELL_LIB_USAGE_ERROR
  62. fi
  63.  
  64. if [ -z "$THIS_SCRIPT" ]; then
  65.   cat >&2 <<EOF
  66. Error: package maintainer script attempted to use shell library without
  67. definining \$THIS_SCRIPT shell variable.  Please report the package name,
  68. version, and the text of this error message to the Debian Bug Tracking System.
  69. Visit <http://www.debian.org/Bugs/Reporting> on the World Wide Web for
  70. instructions, read the file /usr/share/doc/debian/bug-reporting.txt from the
  71. "doc-debian" package, or install the "reportbug" package and use the command of
  72. the same name to file a report against version $SOURCE_VERSION of the
  73. "$THIS_PACKAGE" package.
  74. EOF
  75.   exit $SHELL_LIB_USAGE_ERROR
  76. fi
  77.  
  78. if [ "$1" = "reconfigure" ] || [ -n "$DEBCONF_RECONFIGURE" ]; then
  79.   RECONFIGURE="true"
  80. else
  81.   RECONFIGURE=
  82. fi
  83.  
  84. if ([ "$1" = "install" ] || [ "$1" = "configure" ]) && [ -z "$2" ]; then
  85.   FIRSTINST="yes"
  86. fi
  87.  
  88. if [ -z "$RECONFIGURE" ] && [ -z "$FIRSTINST" ]; then
  89.   UPGRADE="yes"
  90. fi
  91.  
  92. trap "message;\
  93.       message \"Received signal.  Aborting $THIS_PACKAGE package $THIS_SCRIPT script.\";\
  94.       message;\
  95.       exit 1" HUP INT QUIT TERM
  96.  
  97. reject_nondigits () {
  98.   # syntax: reject_nondigits [ operand ... ]
  99.   #
  100.   # scan operands (typically shell variables whose values cannot be trusted) for
  101.   # characters other than decimal digits and barf if any are found
  102.   while [ -n "$1" ]; do
  103.     # does the operand contain anything but digits?
  104.     if ! expr "$1" : "[[:digit:]]\+$" > /dev/null 2>&1; then
  105.       # can't use die(), because it wraps message() which wraps this function
  106.       echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_nondigits() encountered" \
  107.            "possibly malicious garbage \"$1\"" >&2
  108.       exit $SHELL_LIB_THROWN_ERROR
  109.     fi
  110.     shift
  111.   done
  112. }
  113.  
  114. reject_whitespace () {
  115.   # syntax: reject_whitespace [ operand ]
  116.   #
  117.   # scan operand (typically a shell variable whose value cannot be trusted) for
  118.   # whitespace characters and barf if any are found
  119.   if [ -n "$1" ]; then
  120.     # does the operand contain any whitespace?
  121.     if expr "$1" : "[[:space:]]" > /dev/null 2>&1; then
  122.       # can't use die(), because I want to avoid forward references
  123.       echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_whitespace() encountered" \
  124.            "possibly malicious garbage \"$1\"" >&2
  125.       exit $SHELL_LIB_THROWN_ERROR
  126.     fi
  127.   fi
  128. }
  129.  
  130. reject_unlikely_path_chars () {
  131.   # syntax: reject_unlikely_path_chars [ operand ... ]
  132.   #
  133.   # scan operands (typically shell variables whose values cannot be trusted) for
  134.   # characters unlikely to be seen in a path and which the shell might
  135.   # interpret and barf if any are found
  136.   while [ -n "$1" ]; do
  137.     # does the operand contain any funny characters?
  138.     if expr "$1" : '.*[!$&()*;<>?|].*' > /dev/null 2>&1; then
  139.       # can't use die(), because I want to avoid forward references
  140.       echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_unlikely_path_chars()" \
  141.            "encountered possibly malicious garbage \"$1\"" >&2
  142.       exit $SHELL_LIB_THROWN_ERROR
  143.     fi
  144.     shift
  145.   done
  146. }
  147.  
  148. # Query the terminal to establish a default number of columns to use for
  149. # displaying messages to the user.  This is used only as a fallback in the
  150. # event the COLUMNS variable is not set.  ($COLUMNS can react to SIGWINCH while
  151. # the script is running, and this cannot, only being calculated once.)
  152. DEFCOLUMNS=$(stty size 2> /dev/null | awk '{print $2}') || true
  153. if ! expr "$DEFCOLUMNS" : "[[:digit:]]\+$" > /dev/null 2>&1; then
  154.   DEFCOLUMNS=80
  155. fi
  156.  
  157. message () {
  158.   # pretty-print messages of arbitrary length
  159.   reject_nondigits "$COLUMNS"
  160.   echo "$*" | fmt -t -w ${COLUMNS:-$DEFCOLUMNS} >&2
  161. }
  162.  
  163. observe () {
  164.   # syntax: observe message ...
  165.   #
  166.   # issue observational message suitable for logging someday when support for
  167.   # it exists in dpkg
  168.   if [ -n "$DEBUG_XORG_PACKAGE" ]; then
  169.     message "$THIS_PACKAGE $THIS_SCRIPT note: $*"
  170.   fi
  171. }
  172.  
  173. warn () {
  174.   # syntax: warn message ...
  175.   #
  176.   # issue warning message suitable for logging someday when support for
  177.   # it exists in dpkg; also send to standard error
  178.   message "$THIS_PACKAGE $THIS_SCRIPT warning: $*"
  179. }
  180.  
  181. die () {
  182.   # syntax: die message ...
  183.   #
  184.   # exit script with error message
  185.   message "$THIS_PACKAGE $THIS_SCRIPT error: $*"
  186.   exit $SHELL_LIB_THROWN_ERROR
  187. }
  188.  
  189. internal_error () {
  190.   # exit script with error; essentially a "THIS SHOULD NEVER HAPPEN" message
  191.   message "internal error: $*"
  192.   if [ -n "$OFFICIAL_BUILD" ]; then
  193.     message "Please report a bug in the $THIS_SCRIPT script of the" \
  194.             "$THIS_PACKAGE package, version $SOURCE_VERSION to the Debian Bug" \
  195.             "Tracking System.  Include all messages above that mention the" \
  196.             "$THIS_PACKAGE package.  Visit " \
  197.             "<http://www.debian.org/Bugs/Reporting> on the World Wide Web for" \
  198.             "instructions, read the file" \
  199.             "/usr/share/doc/debian/bug-reporting.txt from the doc-debian" \
  200.             "package, or install the reportbug package and use the command of" \
  201.             "the same name to file a report."
  202.   fi
  203.   exit $SHELL_LIB_INTERNAL_ERROR
  204. }
  205.  
  206. usage_error () {
  207.   message "usage error: $*"
  208.   message "Please report a bug in the $THIS_SCRIPT script of the" \
  209.           "$THIS_PACKAGE package, version $SOURCE_VERSION to the Debian Bug" \
  210.           "Tracking System.  Include all messages above that mention the" \
  211.           "$THIS_PACKAGE package.  Visit " \
  212.           "<http://www.debian.org/Bugs/Reporting> on the World Wide Web for" \
  213.           "instructions, read the file" \
  214.           "/usr/share/doc/debian/bug-reporting.txt from the doc-debian" \
  215.           "package, or install the reportbug package and use the command of" \
  216.           "the same name to file a report."
  217.   exit $SHELL_LIB_USAGE_ERROR
  218. }
  219.  
  220.  
  221. maplink () {
  222.   # returns what symlink should point to; i.e., what the "sane" answer is
  223.   # Keep this in sync with the debian/*.links files.
  224.   # This is only needed for symlinks to directories.
  225.   #
  226.   # XXX: Most of these look wrong in the X11R7 world and need to be fixed.
  227.   # If we've stopped using this function, fixing it might enable us to re-enable
  228.   # it again and catch more errors.
  229.   case "$1" in
  230.     /etc/X11/xkb/compiled) echo /var/lib/xkb ;;
  231.     /etc/X11/xkb/xkbcomp) echo /usr/X11R6/bin/xkbcomp ;;
  232.     /usr/X11R6/lib/X11/app-defaults) echo /etc/X11/app-defaults ;;
  233.     /usr/X11R6/lib/X11/fs) echo /etc/X11/fs ;;
  234.     /usr/X11R6/lib/X11/lbxproxy) echo /etc/X11/lbxproxy ;;
  235.     /usr/X11R6/lib/X11/proxymngr) echo /etc/X11/proxymngr ;;
  236.     /usr/X11R6/lib/X11/rstart) echo /etc/X11/rstart ;;
  237.     /usr/X11R6/lib/X11/twm) echo /etc/X11/twm ;;
  238.     /usr/X11R6/lib/X11/xdm) echo /etc/X11/xdm ;;
  239.     /usr/X11R6/lib/X11/xinit) echo /etc/X11/xinit ;;
  240.     /usr/X11R6/lib/X11/xkb) echo /etc/X11/xkb ;;
  241.     /usr/X11R6/lib/X11/xserver) echo /etc/X11/xserver ;;
  242.     /usr/X11R6/lib/X11/xsm) echo /etc/X11/xsm ;;
  243.     /usr/bin/X11) echo ../X11R6/bin ;;
  244.     /usr/bin/rstartd) echo ../X11R6/bin/rstartd ;;
  245.     /usr/include/X11) echo ../X11R6/include/X11 ;;
  246.     /usr/lib/X11) echo ../X11R6/lib/X11 ;;
  247.     *) internal_error "maplink() called with unknown path \"$1\"" ;;
  248.   esac
  249. }
  250.  
  251. analyze_path () {
  252.   # given a supplied set of pathnames, break each one up by directory and do an
  253.   # ls -dl on each component, cumulatively; i.e.
  254.   # analyze_path /usr/X11R6/bin -> ls -dl /usr /usr/X11R6 /usr/X11R6/bin
  255.   # Thanks to Randolph Chung for this clever hack.
  256.  
  257.   local f g
  258.  
  259.   while [ -n "$1" ]; do
  260.     reject_whitespace "$1"
  261.     g=
  262.     message "Analyzing $1:"
  263.     for f in $(echo "$1" | tr / \  ); do
  264.       if [ -e /$g$f ]; then
  265.         ls -dl /$g$f /$g$f.dpkg-* 2> /dev/null || true
  266.         g=$g$f/
  267.       else
  268.         message "/$g$f: nonexistent; directory contents of /$g:"
  269.         ls -l /$g
  270.         break
  271.       fi
  272.     done
  273.     shift
  274.   done
  275. }
  276.  
  277. find_culprits () {
  278.   local f p dpkg_info_dir possible_culprits smoking_guns bad_packages package \
  279.     msg
  280.  
  281.   reject_whitespace "$1"
  282.   message "Searching for overlapping packages..."
  283.   dpkg_info_dir=/var/lib/dpkg/info
  284.   if [ -d $dpkg_info_dir ]; then
  285.     if [ "$(echo $dpkg_info_dir/*.list)" != "$dpkg_info_dir/*.list" ]; then
  286.       possible_culprits=$(ls -1 $dpkg_info_dir/*.list | egrep -v \
  287.         "(xbase-clients|x11-common|xfs|xlibs)")
  288.       if [ -n "$possible_culprits" ]; then
  289.         smoking_guns=$(grep -l "$1" $possible_culprits || true)
  290.         if [ -n "$smoking_guns" ]; then
  291.           bad_packages=$(printf "\\n")
  292.           for f in $smoking_guns; do
  293.             # too bad you can't nest parameter expansion voodoo
  294.             p=${f%*.list}      # strip off the trailing ".list"
  295.             package=${p##*/}   # strip off the directories
  296.             bad_packages=$(printf "%s\n%s" "$bad_packages" "$package")
  297.           done
  298.           msg=$(cat <<EOF
  299. The following packages appear to have file overlaps with the X.Org packages;
  300. these packages are either very old, or in violation of Debian Policy.  Try
  301. upgrading each of these packages to the latest available version if possible:
  302. for example, with the command "apt-get install".  If no newer version of a
  303. package is available, you will have to remove it; for example, with the command
  304. "apt-get remove".  If even the latest available version of the package has
  305. this file overlap, please file a bug against that package with the Debian Bug
  306. Tracking System.  You may want to refer the package maintainer to section 12.8
  307. of the Debian Policy manual.
  308. EOF
  309. )
  310.           message "$msg"
  311.           message "The overlapping packages are: $bad_packages"
  312.         else
  313.           message "no overlaps found."
  314.         fi
  315.       fi
  316.     else
  317.       message "cannot search; no matches for $dpkg_info_dir/*.list."
  318.     fi
  319.   else
  320.     message "cannot search; $dpkg_info_dir does not exist."
  321.   fi
  322. }
  323.  
  324. check_symlink () {
  325.   # syntax: check_symlink symlink
  326.   #
  327.   # See if specified symlink points where it is supposed to.  Return 0 if it
  328.   # does, and 1 if it does not.
  329.   #
  330.   # Primarily used by check_symlinks_and_warn() and check_symlinks_and_bomb().
  331.  
  332.   local symlink
  333.  
  334.   # validate arguments
  335.   if [ $# -ne 1 ]; then
  336.     usage_error "check_symlink() called with wrong number of arguments;" \
  337.                 "expected 1, got $#"
  338.     exit $SHELL_LIB_USAGE_ERROR
  339.   fi
  340.  
  341.   symlink="$1"
  342.  
  343.   if [ "$(maplink "$symlink")" = "$(readlink "$symlink")" ]; then
  344.     return 0
  345.   else
  346.     return 1
  347.   fi
  348. }
  349.  
  350. check_symlinks_and_warn () {
  351.   # syntax: check_symlinks_and_warn symlink ...
  352.   #
  353.   # For each argument, check for symlink sanity, and warn if it isn't sane.
  354.   #
  355.   # Call this function from a preinst script in the event $1 is "upgrade" or
  356.   # "install".
  357.  
  358.   local errmsg symlink
  359.  
  360.   # validate arguments
  361.   if [ $# -lt 1 ]; then
  362.     usage_error "check_symlinks_and_warn() called with wrong number of" \
  363.                 "arguments; expected at least 1, got $#"
  364.     exit $SHELL_LIB_USAGE_ERROR
  365.   fi
  366.  
  367.   while [ -n "$1" ]; do
  368.     symlink="$1"
  369.     if [ -L "$symlink" ]; then
  370.       if ! check_symlink "$symlink"; then
  371.         observe "$symlink symbolic link points to wrong location" \
  372.                 "$(readlink "$symlink"); removing"
  373.         rm "$symlink"
  374.       fi
  375.     elif [ -e "$symlink" ]; then
  376.       errmsg="$symlink exists and is not a symbolic link; this package cannot"
  377.       errmsg="$errmsg be installed until this"
  378.       if [ -f "$symlink" ]; then
  379.         errmsg="$errmsg file"
  380.       elif [ -d "$symlink" ]; then
  381.         errmsg="$errmsg directory"
  382.       else
  383.         errmsg="$errmsg thing"
  384.       fi
  385.       errmsg="$errmsg is removed"
  386.       die "$errmsg"
  387.     fi
  388.     shift
  389.   done
  390. }
  391.  
  392. check_symlinks_and_bomb () {
  393.   # syntax: check_symlinks_and_bomb symlink ...
  394.   #
  395.   # For each argument, check for symlink sanity, and bomb if it isn't sane.
  396.   #
  397.   # Call this function from a postinst script.
  398.  
  399.   local problem symlink
  400.  
  401.   # validate arguments
  402.   if [ $# -lt 1 ]; then
  403.     usage_error "check_symlinks_and_bomb() called with wrong number of"
  404.                 "arguments; expected at least 1, got $#"
  405.     exit $SHELL_LIB_USAGE_ERROR
  406.   fi
  407.  
  408.   while [ -n "$1" ]; do
  409.     problem=
  410.     symlink="$1"
  411.     if [ -L "$symlink" ]; then
  412.       if ! check_symlink "$symlink"; then
  413.         problem=yes
  414.         warn "$symlink symbolic link points to wrong location" \
  415.              "$(readlink "$symlink")"
  416.       fi
  417.     elif [ -e "$symlink" ]; then
  418.       problem=yes
  419.       warn "$symlink is not a symbolic link"
  420.     else
  421.       problem=yes
  422.       warn "$symlink symbolic link does not exist"
  423.     fi
  424.     if [ -n "$problem" ]; then
  425.       analyze_path "$symlink" "$(readlink "$symlink")"
  426.       find_culprits "$symlink"
  427.       die "bad symbolic links on system"
  428.     fi
  429.     shift
  430.   done
  431. }
  432.  
  433. font_update () {
  434.   # run $UPDATECMDS in $FONTDIRS
  435.  
  436.   local dir cmd shortcmd x_font_dir_prefix
  437.  
  438.   x_font_dir_prefix="/usr/share/fonts/X11"
  439.  
  440.   if [ -z "$UPDATECMDS" ]; then
  441.     usage_error "font_update() called but \$UPDATECMDS not set"
  442.   fi
  443.   if [ -z "$FONTDIRS" ]; then
  444.     usage_error "font_update() called but \$FONTDIRS not set"
  445.   fi
  446.  
  447.   reject_unlikely_path_chars "$UPDATECMDS"
  448.   reject_unlikely_path_chars "$FONTDIRS"
  449.  
  450.   for dir in $FONTDIRS; do
  451.     if [ -d "$x_font_dir_prefix/$dir" ]; then
  452.       for cmd in $UPDATECMDS; do
  453.         if which "$cmd" > /dev/null 2>&1; then
  454.           shortcmd=${cmd##*/}
  455.           observe "running $shortcmd in $dir font directory"
  456.       cmd_opts=
  457.           if [ "$shortcmd" = "update-fonts-alias" ]; then
  458.             cmd_opts=--x11r7-layout
  459.           fi
  460.           if [ "$shortcmd" = "update-fonts-dir" ]; then
  461.             cmd_opts=--x11r7-layout
  462.           fi
  463.           if [ "$shortcmd" = "update-fonts-scale" ]; then
  464.             cmd_opts=--x11r7-layout
  465.           fi
  466.           $cmd $cmd_opts $dir || warn "$cmd $cmd_opts $dir" \
  467.                               "failed; font directory data may not" \
  468.                               "be up to date"
  469.         else
  470.           warn "$cmd not found; not updating corresponding $dir font" \
  471.                "directory data"
  472.         fi
  473.       done
  474.     else
  475.       warn "$dir is not a directory; not updating font directory data"
  476.     fi
  477.   done
  478. }
  479.  
  480. remove_conffile_prepare () {
  481.   # syntax: remove_conffile_prepare filename official_md5sum ...
  482.   #
  483.   # Check a conffile "filename" against a list of canonical MD5 checksums.
  484.   # If the file's current MD5 checksum matches one of the "official_md5sum"
  485.   # operands provided, then prepare the conffile for removal from the system.
  486.   # We defer actual deletion until the package is configured so that we can
  487.   # roll this operation back if package installation fails.
  488.   #
  489.   # Call this function from a preinst script in the event $1 is "upgrade" or
  490.   # "install" and verify $2 to ensure the package is being upgraded from a
  491.   # version (or installed over a version removed-but-not-purged) prior to the
  492.   # one in which the conffile was obsoleted.
  493.  
  494.   local conffile current_checksum
  495.  
  496.   # validate arguments
  497.   if [ $# -lt 2 ]; then
  498.     usage_error "remove_conffile_prepare() called with wrong number of" \
  499.                 "arguments; expected at least 2, got $#"
  500.     exit $SHELL_LIB_USAGE_ERROR
  501.   fi
  502.  
  503.   conffile="$1"
  504.   shift
  505.  
  506.   # does the conffile even exist?
  507.   if [ -e "$conffile" ]; then
  508.     # calculate its checksum
  509.     current_checksum=$(md5sum < "$conffile" | sed 's/[[:space:]].*//')
  510.     # compare it to each supplied checksum
  511.     while [ -n "$1" ]; do
  512.       if [ "$current_checksum" = "$1" ]; then
  513.         # we found a match; move the confffile and stop looking
  514.         observe "preparing obsolete conffile $conffile for removal"
  515.         mv "$conffile" "$conffile.$THIS_PACKAGE-tmp"
  516.         break
  517.       fi
  518.       shift
  519.     done
  520.   fi
  521. }
  522.  
  523. remove_conffile_lookup () {
  524.   # syntax: remove_conffile_lookup package filename
  525.   #
  526.   # Lookup the md5sum of a conffile in dpkg's database, and prepare for removal
  527.   # if it matches the actual file's md5sum.
  528.   #
  529.   # Call this function when you would call remove_conffile_prepare but only
  530.   # want to check against dpkg's status database instead of known checksums.
  531.  
  532.   local package conffile old_md5sum
  533.  
  534.   # validate arguments
  535.   if [ $# -ne 2 ]; then
  536.     usage_error "remove_conffile_lookup() called with wrong number of" \
  537.                 "arguments; expected 1, got $#"
  538.     exit $SHELL_LIB_USAGE_ERROR
  539.   fi
  540.  
  541.   package="$1"
  542.   conffile="$2"
  543.  
  544.   if ! [ -e "$conffile" ]; then
  545.     return
  546.   fi
  547.   old_md5sum="$(dpkg-query -W -f='${Conffiles}' "$package" | \
  548.     awk '{ if (match($0, "^ '"$conffile"' ")) print $2}')"
  549.   if [ -n "$old_md5sum" ]; then
  550.     remove_conffile_prepare "$conffile" "$old_md5sum"
  551.   fi
  552. }
  553.  
  554. remove_conffile_commit () {
  555.   # syntax: remove_conffile_commit filename
  556.   #
  557.   # Complete the removal of a conffile "filename" that has become obsolete.
  558.   #
  559.   # Call this function from a postinst script after having used
  560.   # remove_conffile_prepare() in the preinst.
  561.  
  562.   local conffile
  563.  
  564.   # validate arguments
  565.   if [ $# -ne 1 ]; then
  566.     usage_error "remove_conffile_commit() called with wrong number of" \
  567.                 "arguments; expected 1, got $#"
  568.     exit $SHELL_LIB_USAGE_ERROR
  569.   fi
  570.  
  571.   conffile="$1"
  572.  
  573.   # if the temporary file created by remove_conffile_prepare() exists, remove it
  574.   if [ -e "$conffile.$THIS_PACKAGE-tmp" ]; then
  575.     observe "committing removal of obsolete conffile $conffile"
  576.     rm "$conffile.$THIS_PACKAGE-tmp"
  577.   fi
  578. }
  579.  
  580. remove_conffile_rollback () {
  581.   # syntax: remove_conffile_rollback filename
  582.   #
  583.   # Roll back the removal of a conffile "filename".
  584.   #
  585.   # Call this function from a postrm script in the event $1 is "abort-upgrade"
  586.   # or "abort-install" is  after having used remove_conffile_prepare() in the
  587.   # preinst.
  588.  
  589.   local conffile
  590.  
  591.   # validate arguments
  592.   if [ $# -ne 1 ]; then
  593.     usage_error "remove_conffile_rollback() called with wrong number of" \
  594.                 "arguments; expected 1, got $#"
  595.     exit $SHELL_LIB_USAGE_ERROR
  596.   fi
  597.  
  598.   conffile="$1"
  599.  
  600.   # if the temporary file created by remove_conffile_prepare() exists, move it
  601.   # back
  602.   if [ -e "$conffile.$THIS_PACKAGE-tmp" ]; then
  603.     observe "rolling back removal of obsolete conffile $conffile"
  604.     mv "$conffile.$THIS_PACKAGE-tmp" "$conffile"
  605.   fi
  606. }
  607.  
  608. replace_conffile_with_symlink_prepare () {
  609.   # syntax: replace_conffile_with_symlink_prepare oldfilename newfilename \
  610.   # official_md5sum ...
  611.   #
  612.   # Check a conffile "oldfilename" against a list of canonical MD5 checksums.
  613.   # If the file's current MD5 checksum matches one of the "official_md5sum"
  614.   # operands provided, then prepare the conffile for removal from the system.
  615.   # We defer actual deletion until the package is configured so that we can
  616.   # roll this operation back if package installation fails. Otherwise copy it
  617.   # to newfilename and let dpkg handle it through conffiles mechanism.
  618.   #
  619.   # Call this function from a preinst script in the event $1 is "upgrade" or
  620.   # "install" and verify $2 to ensure the package is being upgraded from a
  621.   # version (or installed over a version removed-but-not-purged) prior to the
  622.   # one in which the conffile was obsoleted.
  623.  
  624.   local conffile current_checksum
  625.  
  626.   # validate arguments
  627.   if [ $# -lt 3 ]; then
  628.     usage_error "replace_conffile_with_symlink_prepare() called with wrong" \
  629.                 " number of arguments; expected at least 3, got $#"
  630.     exit $SHELL_LIB_USAGE_ERROR
  631.   fi
  632.  
  633.   oldconffile="$1"
  634.   shift
  635.   newconffile="$1"
  636.   shift
  637.  
  638.   remove_conffile_prepare "$_oldconffile" "$@"
  639.   # If $oldconffile still exists, then md5sums didn't match.
  640.   # Copy it to new one.
  641.   if [ -f "$oldconffile" ]; then
  642.     cp "$oldconffile" "$newconffile"
  643.   fi
  644.  
  645. }
  646.  
  647. replace_conffile_with_symlink_commit () {
  648.   # syntax: replace_conffile_with_symlink_commit oldfilename
  649.   #
  650.   # Complete the removal of a conffile "oldfilename" that has been
  651.   # replaced by a symlink.
  652.   #
  653.   # Call this function from a postinst script after having used
  654.   # replace_conffile_with_symlink_prepare() in the preinst.
  655.  
  656.   local conffile
  657.  
  658.   # validate arguments
  659.   if [ $# -ne 1 ]; then
  660.     usage_error "replace_conffile_with_symlink_commit() called with wrong" \
  661.                 "number of arguments; expected 1, got $#"
  662.     exit $SHELL_LIB_USAGE_ERROR
  663.   fi
  664.  
  665.   conffile="$1"
  666.  
  667.   remove_conffile_commit "$conffile"
  668. }
  669.  
  670. replace_conffile_with_symlink_rollback () {
  671.   # syntax: replace_conffile_with_symlink_rollback oldfilename newfilename
  672.   #
  673.   # Roll back the replacing of a conffile "oldfilename" with symlink to
  674.   # "newfilename".
  675.   #
  676.   # Call this function from a postrm script in the event $1 is "abort-upgrade"
  677.   # or "abort-install" and verify $2 to ensure the package failed to upgrade
  678.   # from a version (or install over a version removed-but-not-purged) prior
  679.   # to the one in which the conffile was obsoleted.
  680.   # You should have  used replace_conffile_with_symlink_prepare() in the
  681.   # preinst.
  682.  
  683.   local conffile
  684.  
  685.   # validate arguments
  686.   if [ $# -ne 2 ]; then
  687.     usage_error "replace_conffile_with_symlink_rollback() called with wrong" \
  688.                 "number of arguments; expected 2, got $#"
  689.     exit $SHELL_LIB_USAGE_ERROR
  690.   fi
  691.  
  692.   oldconffile="$1"
  693.   newconffile="$2"
  694.  
  695.   remove_conffile_rollback "$_oldconffile"
  696.   if [ -f "$newconffile" ]; then
  697.     rm "$newconffile"
  698.   fi
  699. }
  700.  
  701. run () {
  702.   # syntax: run command [ argument ... ]
  703.   #
  704.   # Run specified command with optional arguments and report its exit status.
  705.   # Useful for commands whose exit status may be nonzero, but still acceptable,
  706.   # or commands whose failure is not fatal to us.
  707.   #
  708.   # NOTE: Do *not* use this function with db_get or db_metaget commands; in
  709.   # those cases the return value of the debconf command *must* be checked
  710.   # before the string returned by debconf is used for anything.
  711.  
  712.   local retval
  713.  
  714.   # validate arguments
  715.   if [ $# -lt 1 ]; then
  716.     usage_error "run() called with wrong number of arguments; expected at" \
  717.                 "least 1, got $#"
  718.     exit $SHELL_LIB_USAGE_ERROR
  719.   fi
  720.  
  721.   "$@" || retval=$?
  722.  
  723.   if [ ${retval:-0} -ne 0 ]; then
  724.     observe "command \"$*\" exited with status $retval"
  725.   fi
  726. }
  727.  
  728. make_symlink_sane () {
  729.   # syntax: make_symlink_sane symlink target
  730.   #
  731.   # Ensure that the symbolic link symlink exists, and points to target.
  732.   #
  733.   # If symlink does not exist, create it and point it at target.
  734.   #
  735.   # If symlink exists but is not a symbolic link, back it up.
  736.   #
  737.   # If symlink exists, is a symbolic link, but points to the wrong location, fix
  738.   # it.
  739.   #
  740.   # If symlink exists, is a symbolic link, and already points to target, do
  741.   # nothing.
  742.   #
  743.   # This function wouldn't be needed if ln had an -I, --idempotent option.
  744.  
  745.   # Validate arguments.
  746.   if [ $# -ne 2 ]; then
  747.     usage_error "make_symlink_sane() called with wrong number of arguments;" \
  748.       "expected 2, got $#"
  749.     exit $SHELL_LIB_USAGE_ERROR
  750.   fi
  751.  
  752.   # We could just use the positional parameters as-is, but that makes things
  753.   # harder to follow.
  754.   local symlink target
  755.  
  756.   symlink="$1"
  757.   target="$2"
  758.  
  759.   if [ -L "$symlink" ] && [ "$(readlink "$symlink")" = "$target" ]; then
  760.       observe "link from $symlink to $target already exists"
  761.   else
  762.     observe "creating symbolic link from $symlink to $target"
  763.     mkdir -p "${target%/*}" "${symlink%/*}"
  764.     ln -s -b -S ".dpkg-old" "$target" "$symlink"
  765.   fi
  766. }
  767.  
  768. migrate_dir_to_symlink () {
  769.   # syntax: migrate_dir_to_symlink old_location new_location
  770.   #
  771.   # Per Debian Policy section 6.5.4, "A directory will never be replaced by a
  772.   # symbolic link to a directory or vice versa; instead, the existing state
  773.   # (symlink or not) will be left alone and dpkg will follow the symlink if
  774.   # there is one."
  775.   #
  776.   # We have to do it ourselves.
  777.   #
  778.   # This function moves the contents of old_location, a directory, into
  779.   # new_location, a directory, then makes old_location a symbolic link to
  780.   # new_location.
  781.   #
  782.   # old_location need not exist, but if it does, it must be a directory (or a
  783.   # symlink to a directory).  If it is not, it is backed up.  If new_location
  784.   # exists already and is not a directory, it is backed up.
  785.   #
  786.   # This function should be called from a package's preinst so that other
  787.   # packages unpacked after this one --- but before this package's postinst runs
  788.   # --- are unpacked into new_location even if their payloads contain
  789.   # old_location filespecs.
  790.  
  791.   # Validate arguments.
  792.   if [ $# -ne 2 ]; then
  793.     usage_error "migrate_dir_to_symlink() called with wrong number of"
  794.                 "arguments; expected 2, got $#"
  795.     exit $SHELL_LIB_USAGE_ERROR
  796.   fi
  797.  
  798.   # We could just use the positional parameters as-is, but that makes things
  799.   # harder to follow.
  800.   local new old
  801.  
  802.   old="$1"
  803.   new="$2"
  804.  
  805.   # Is old location a symlink?
  806.   if [ -L "$old" ]; then
  807.     # Does it already point to new location?
  808.     if [ "$(readlink "$old")" = "$new" ]; then
  809.       # Nothing to do; migration has already been done.
  810.       observe "migration of $old to $new already done"
  811.       return 0
  812.     else
  813.       # Back it up.
  814.       warn "backing up symbolic link $old as $old.dpkg-old"
  815.       mv -b "$old" "$old.dpkg-old"
  816.     fi
  817.   fi
  818.  
  819.   # Does old location exist, but is not a directory?
  820.   if [ -e "$old" ] && ! [ -d "$old" ]; then
  821.       # Back it up.
  822.       warn "backing up non-directory $old as $old.dpkg-old"
  823.       mv -b "$old" "$old.dpkg-old"
  824.   fi
  825.  
  826.   observe "migrating $old to $new"
  827.  
  828.   # Is new location a symlink?
  829.   if [ -L "$new" ]; then
  830.     # Does it point the wrong way, i.e., back to where we're migrating from?
  831.     if [ "$(readlink "$new")" = "$old" ]; then
  832.       # Get rid of it.
  833.       observe "removing symbolic link $new which points to $old"
  834.       rm "$new"
  835.     else
  836.       # Back it up.
  837.       warn "backing up symbolic link $new as $new.dpkg-old"
  838.       mv -b "$new" "$new.dpkg-old"
  839.     fi
  840.   fi
  841.  
  842.   # Does new location exist, but is not a directory?
  843.   if [ -e "$new" ] && ! [ -d "$new" ]; then
  844.     warn "backing up non-directory $new as $new.dpkg-old"
  845.     mv -b "$new" "$new.dpkg-old"
  846.   fi
  847.  
  848.   # Create new directory if it does not yet exist.
  849.   if ! [ -e "$new" ]; then
  850.     observe "creating $new"
  851.     mkdir -p "$new"
  852.   fi
  853.  
  854.   # Copy files in old location to new location.  Back up any filenames that
  855.   # already exist in the new location with the extension ".dpkg-old".
  856.   observe "copying files from $old to $new"
  857.   if ! (cd "$old" && cp -a -b -S ".dpkg-old" . "$new"); then
  858.     die "error(s) encountered while copying files from $old to $new"
  859.   fi
  860.  
  861.   # Remove files at old location.
  862.   observe "removing $old"
  863.   rm -r "$old"
  864.  
  865.   # Create symlink from old location to new location.
  866.   make_symlink_sane "$old" "$new"
  867. }
  868.  
  869. # vim:set ai et sw=2 ts=2 tw=80:
  870.  
  871. # GOBSTOPPER: The X Strike Force shell library ends here.
  872.  
  873. case "$1" in
  874. abort-install|abort-upgrade)
  875.   if dpkg --compare-versions "$2" lt-nl "1:7.4~2ubuntu1"; then
  876.     remove_conffile_rollback "/etc/X11/Xsession.d/20xorg-common_process-args"
  877.     remove_conffile_rollback "/etc/X11/Xsession.d/30xorg-common_xresources"
  878.     remove_conffile_rollback "/etc/X11/Xsession.d/50xorg-common_determine-startup"
  879.     remove_conffile_rollback "/etc/X11/Xsession.d/90xorg-common_ssh-agent"
  880.     remove_conffile_rollback "/etc/X11/Xsession.d/99xorg-common_start"
  881.   fi
  882.   if dpkg --compare-versions "$2" lt-nl "1:7.4~5ubuntu16"; then
  883.     remove_conffile_rollback "/etc/X11/Xsession.d/60x11-localhost"
  884.   fi
  885. esac
  886.  
  887. # clean up non-conffile configuration files and related materials on purge
  888. if [ "$1" = "purge" ]; then
  889.   # de-register this package as a handler of the X server wrapper config file
  890.   if [ -e "$XWRAPPER_CONFIG_ROSTER" ]; then
  891.     # check existing roster file for our package name
  892.     if fgrep -qx "$THIS_PACKAGE" "$XWRAPPER_CONFIG_ROSTER" 2>/dev/null; then
  893.       # construct temporary roster file with our package name removed, ignoring
  894.       # failure
  895.       fgrep -vx "$THIS_PACKAGE" "$XWRAPPER_CONFIG_ROSTER" > \
  896.         "$XWRAPPER_CONFIG_ROSTER.dpkg-tmp" 2>/dev/null || true
  897.       # is there anything left?
  898.       if [ -s "$XWRAPPER_CONFIG_ROSTER.dpkg-tmp" ]; then
  899.         # yes, replace the roster file
  900.         mv "$XWRAPPER_CONFIG_ROSTER.dpkg-tmp" "$XWRAPPER_CONFIG_ROSTER"
  901.       else
  902.         # no; remove both the roster and our temporary copy
  903.         rm -f "$XWRAPPER_CONFIG_ROSTER" "$XWRAPPER_CONFIG_ROSTER.dpkg-tmp"
  904.         # remove X server wrapper config file if it was still managed by the
  905.         # package
  906.         if [ -e "$XWRAPPER_CONFIG_CHECKSUM" ]; then
  907.           # does it exist?
  908.           if [ -e "$XWRAPPER_CONFIG" ]; then
  909.             # does the current MD5 checksum match the stored checksum?
  910.             if [ "$(md5sum "$XWRAPPER_CONFIG")" \
  911.                  = "$(cat "$XWRAPPER_CONFIG_CHECKSUM")" ]; then
  912.               # yes; remove the config file
  913.               rm -f "$XWRAPPER_CONFIG"
  914.             fi
  915.           fi
  916.           # remove the checksum file; any remaining X server wrapper config file
  917.           # still on the system at this point is no longer being managed (local
  918.           # user customization)
  919.           rm -f "$XWRAPPER_CONFIG_CHECKSUM"
  920.         fi
  921.       fi
  922.     fi
  923.   fi
  924.  
  925.   for DIR in "$CONFIG_DIR" "$CONFIG_AUX_DIR"; do
  926.       rmdir "$DIR" 2> /dev/null || true
  927.   done
  928. fi
  929.  
  930. # Automatically added by dh_installdebconf
  931. if [ "$1" = purge ] && [ -e /usr/share/debconf/confmodule ]; then
  932.     . /usr/share/debconf/confmodule
  933.     db_purge
  934. fi
  935. # End automatically added section
  936. # Automatically added by dh_installinit
  937. if [ "$1" = "purge" ] ; then
  938.     update-rc.d x11-common remove >/dev/null || exit $?
  939. fi
  940. # End automatically added section
  941.  
  942.  
  943. exit 0
  944.  
  945. # vim:set ai et sts=2 sw=2 tw=80:
  946.